// -*- C++ -*-
/*!
 * @file  CentroidViewerRTC.cpp
 * @brief ModuleDescription
 * @date $Date$
 *
 * $Id$
 */

#include "CentroidViewerRTC.h"

// Module specification
// <rtc-template block="module_spec">
static const char* centroidviewerrtc_spec[] =
  {
    "implementation_id", "CentroidViewerRTC",
    "type_name",         "CentroidViewerRTC",
    "description",       "ModuleDescription",
    "version",           "1.0.0",
    "vendor",            "Saitama Univ. Design Lab.",
    "category",          "EngineeringSample",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
CentroidViewerRTC::CentroidViewerRTC(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_positionIn("position", m_position),
    m_triggerPort("trigger")

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
CentroidViewerRTC::~CentroidViewerRTC()
{
}



RTC::ReturnCode_t CentroidViewerRTC::onInitialize()
{
	std::cout<<"Initialize"<<std::endl;

  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  addInPort("position", m_positionIn);
  
  // Set OutPort buffer
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  m_triggerPort.registerConsumer("recogPort", "RecognitionService", m_RecognitionService);
  
  // Set CORBA Service Ports
  addPort(m_triggerPort);
  
  // </rtc-template>

  std::cout<<"InitializeI"<<std::endl;

  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t CentroidViewerRTC::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t CentroidViewerRTC::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t CentroidViewerRTC::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t CentroidViewerRTC::onActivated(RTC::UniqueId ec_id)
{
	std::cout<<"Activate"<<std::endl;

  return RTC::RTC_OK;
}


RTC::ReturnCode_t CentroidViewerRTC::onDeactivated(RTC::UniqueId ec_id)
{
	std::cout<<"Deactivate"<<std::endl;

  return RTC::RTC_OK;
}


RTC::ReturnCode_t CentroidViewerRTC::onExecute(RTC::UniqueId ec_id)
{
	if(m_positionIn.isNew()){
			m_positionIn.read();
	std::cout<<"}Sʒu (xW:"<<m_position.data[11]<<"[pixel] "<<"yW:"<<m_position.data[15]<<"[pixel])"<<std::endl;
	}

  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t CentroidViewerRTC::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t CentroidViewerRTC::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t CentroidViewerRTC::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t CentroidViewerRTC::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t CentroidViewerRTC::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void CentroidViewerRTCInit(RTC::Manager* manager)
  {
    coil::Properties profile(centroidviewerrtc_spec);
    manager->registerFactory(profile,
                             RTC::Create<CentroidViewerRTC>,
                             RTC::Delete<CentroidViewerRTC>);
  }
  
};


