// -*- C++ -*-
/*!
 * @file  OperationCommandRTC.cpp
 * @brief ModuleDescription
 * @date $Date$
 *
 * $Id$
 */

#include "OperationCommandRTC.h"

// Module specification
// <rtc-template block="module_spec">
static const char* operationcommandrtc_spec[] =
  {
    "implementation_id", "OperationCommandRTC",
    "type_name",         "OperationCommandRTC",
    "description",       "ModuleDescription",
    "version",           "1.0.0",
    "vendor",            "Saitama Univ. Design Lab.",
    "category",          "Industrial Robot",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables
    "conf.default.OperationFile", "SampleFile.txt",
    // Widget
    "conf.__widget__.OperationFile", "text",
    // Constraints
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
OperationCommandRTC::OperationCommandRTC(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_ManipulatorCommonInterface_CommonPort("ManipulatorCommonInterface_Common"),
    m_ManipulatorCommonInterface_MiddlePort("ManipulatorCommonInterface_Middle")

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
OperationCommandRTC::~OperationCommandRTC()
{
}



RTC::ReturnCode_t OperationCommandRTC::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  
  // Set OutPort buffer
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  m_ManipulatorCommonInterface_CommonPort.registerConsumer("ManipulatorCommonInterface_Common", "JARA_ARM::ManipulatorCommonInterface_Common", m_ManipulatorCommonInterface_Common);
  m_ManipulatorCommonInterface_MiddlePort.registerConsumer("ManipulatorCommonInterface_Middle", "JARA_ARM::ManipulatorCommonInterface_Middle", m_ManipulatorCommonInterface_Middle);
  
  // Set CORBA Service Ports
  addPort(m_ManipulatorCommonInterface_CommonPort);
  addPort(m_ManipulatorCommonInterface_MiddlePort);
  
  // </rtc-template>

  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
  bindParameter("OperationFile", m_OperationFile, "SampleFile.txt");
  
  // </rtc-template>
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t OperationCommandRTC::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t OperationCommandRTC::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t OperationCommandRTC::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t OperationCommandRTC::onActivated(RTC::UniqueId ec_id)
{
	std::cout<<"Activate"<<std::endl;

  return RTC::RTC_OK;
}


RTC::ReturnCode_t OperationCommandRTC::onDeactivated(RTC::UniqueId ec_id)
{
	std::cout<<"Deactivate"<<std::endl;

  return RTC::RTC_OK;
}


RTC::ReturnCode_t OperationCommandRTC::onExecute(RTC::UniqueId ec_id)
{
	char* FileName;
	char c;
	std::cout<<std::endl<<"Input Command (a:Act Operation File , m:Manual Input , e:Exit)"<<std::endl;
	std::cin>>c;

	switch(c){
	case 'a'://t@Cǂݍ
		std::cout<<std::endl<<"Act Operation File"<<std::endl;
		
		//t@C̓ǂݍ
		FILE * fp;
		m_len = m_OperationFile.length();
		FileName = new char[m_len+1];
		memcpy(FileName,m_OperationFile.c_str(),m_len+1);
		fp=fopen( FileName , "r");
		if( fp == NULL ) {
		std::cout<<"t@Cǂݍ߂܂"<<std::endl;
			break;
		}

		//[v
		//1sƂɓǂݍ݁AViIs
		while(fscanf( fp , "%s %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf\n" , m_command , &m_Buf[0] ,&m_Buf[1] , &m_Buf[2] ,&m_Buf[3], &m_Buf[4] ,&m_Buf[5], &m_Buf[6] ,&m_Buf[7], &m_Buf[8] ,&m_Buf[9], &m_Buf[10] ,&m_Buf[11] )!= EOF ) {
			//
			
			std::cout<<"Command :"<<m_command<<std::endl;
			
			if(ActCommand('a') != RTC::RTC_OK){
				return RTC::RTC_ERROR;
			}

		}

		//t@CN[Y
		fclose( fp );

		break;

	case 'm'://R}h
		std::cout<<std::endl<<"Manual Input (c:Common Command , m:MiddleLevelMotion Command)"<<std::endl;
		std::cin>>c;
		switch(c){
		case'c':
			std::cout<<std::endl<<"Common Command"<<std::endl;
			std::cout<<"1:A[NA"<<std::endl<<"2:A[̎擾"<<std::endl<<"3:֐ߍWn̈ʒutB[hobN̎擾"<<std::endl<<"4:}js[^̎擾"<<std::endl<<"5:֐ߍWñ\tg~bgl擾"<<std::endl<<"6:jbg̏Ԏ擾"<<std::endl<<"7:ST[{OFF"<<std::endl<<"8:ST[{ON"<<std::endl<<"9:֐ߍWñ\tg~bglݒ"<<std::endl<<std::endl;
			std::cin>>mode;
			if((mode>=1)&&(mode<=9)){
				mode=mode+100;
				if(ActCommand('m') != RTC::RTC_OK){
					return RTC::RTC_ERROR;
				}
			}
			break;
			
		case'm':
			std::cout<<std::endl<<"MiddleLevelMotion Command"<<std::endl;
			std::cout<<"1:Obp"<<std::endl<<"2:}js[^̐ݒʒu擾"<<std::endl<<"3:Wn̈ʒutB[hobN̎擾"<<std::endl<<"4:𓮍쎞̍ő哮쑬x擾"<<std::endl<<"5:֐ߓ쎞̍ő哮쑬x擾"<<std::endl<<"6:𓮍쎞̍ŏx擾"<<std::endl<<"7:֐ߓ쎞̍ŏx擾"<<std::endl<<"8:Wñ\tg~bgl擾"<<std::endl<<"9:Obp̊J"<<std::endl<<"10:Wn̒(Ύw)"<<std::endl;
			std::cout<<"11:Wn̒(Ύw)"<<std::endl<<"12:֐ߍWn̒(EΎw)"<<std::endl<<"13:֐ߍWn̒(EΎw)"<<std::endl<<"14:֐ߍWn̒(֐߁EΎw)"<<std::endl<<"15:֐ߍWn̒(֐߁EΎw)"<<std::endl<<"16:ObpJ"<<std::endl<<"17:̈ꎞ~"<<std::endl<<"18:̍ĊJ"<<std::endl<<"19:̒~"<<std::endl<<"20:𓮍쎞̉Ԃݒ"<<std::endl;
			std::cout<<"21:֐ߓ쎞̉Ԃݒ"<<std::endl<<"22:}js[^̐ݒuʒuݒ"<<std::endl<<"23:_̃tWʂ̃ItZbgʂݒ"<<std::endl<<"24:𓮍쎞̍ő哮쑬xݒ"<<std::endl<<"25:֐ߓ쎞̍ő哮쑬xݒ"<<std::endl<<"26:𓮍쎞̍ŏԂݒ"<<std::endl<<"27:֐ߓ쎞̍ŏԂݒ"<<std::endl<<"28:Wñ\tg~bglݒ"<<std::endl<<"29:𓮍쎞̑xݒ"<<std::endl<<"30:֐ߓ쎞̑xݒ"<<std::endl;
			std::cout<<"31:Wn̉~ʕ(Ύw)"<<std::endl<<"32:Wn̉~ʕ(Ύw)"<<std::endl<<"33:_ÄʒuEpݒ"<<std::endl<<"34:_ÄʒuEp擾"<<std::endl<<"35:_A"<<std::endl<<std::endl;
			std::cin>>mode;
			if((mode>=1)&&(mode<=35)){
				mode=mode+200;
				if(ActCommand('m') != RTC::RTC_OK){
					return RTC::RTC_ERROR;
				}
			}
			break;
			
		default:
			break;
		}

		break;

	case 'e'://Esc
			std::cout<<std::endl<<"Exit"<<std::endl<<"Ending program"<<std::endl;
			
			deactivate(ec_id);

	break;
	default:
		break;
	}

  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t OperationCommandRTC::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t OperationCommandRTC::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t OperationCommandRTC::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t OperationCommandRTC::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t OperationCommandRTC::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

RTC::ReturnCode_t OperationCommandRTC::ActCommand(char c){
	int i;

	if( c == 'a' ){
		//񂩂m_modeϊ
		
		if(strcmp(m_command,"CLR_ALARM") == 0){
			mode = 101;
		}else if(strcmp(m_command,"GET_ALARM") == 0){
			mode = 102;
		}else if(strcmp(m_command,"GET_JPOS") == 0){
			mode = 103;
		}else if(strcmp(m_command,"GET_MEC") == 0){
			mode = 104;
		}else if(strcmp(m_command,"GET_JSLIM") == 0){
			mode = 105;
		}else if(strcmp(m_command,"GET_STATE") == 0){
			mode = 106;
		}else if(strcmp(m_command,"SERVO_OFF") == 0){
			mode = 107;
		}else if(strcmp(m_command,"SERVO_ON") == 0){
			mode = 108;
		}else if(strcmp(m_command,"SET_JSLIM") == 0){
			mode = 109;
		}else if(strcmp(m_command,"GCLOSE") == 0){
			mode = 201;
		}else if(strcmp(m_command,"GET_BASE") == 0){
			mode = 202;
		}else if(strcmp(m_command,"GET_CFB") == 0){
			mode = 203;
		}else if(strcmp(m_command,"GET_CSPD") == 0){
			mode = 204;
		}else if(strcmp(m_command,"GET_JSPD") == 0){
			mode = 205;
		}else if(strcmp(m_command,"GET_CATLIM") == 0){
			mode = 206;
		}else if(strcmp(m_command,"GET_JATLIM") == 0){
			mode = 207;
		}else if(strcmp(m_command,"GET_CSLIM") == 0){
			mode = 208;
		}else if(strcmp(m_command,"GMOV") == 0){
			mode = 209;
		}else if(strcmp(m_command,"CMVS_ABS") == 0){
			mode = 210;
		}else if(strcmp(m_command,"CMVS_REL") == 0){
			mode = 211;
		}else if(strcmp(m_command,"CMOV_ABS") == 0){
			mode = 212;
		}else if(strcmp(m_command,"CMOV_REL") == 0){
			mode = 213;
		}else if(strcmp(m_command,"JMOV_ABS") == 0){
			mode = 214;
		}else if(strcmp(m_command,"JMOV_REL") == 0){
			mode = 215;
		}else if(strcmp(m_command,"GOPEN") == 0){
			mode = 216;
		}else if(strcmp(m_command,"PAUSE") == 0){
			mode = 217;
		}else if(strcmp(m_command,"RESUME") == 0){
			mode = 218;
		}else if(strcmp(m_command,"STOP") == 0){
			mode = 219;
		}else if(strcmp(m_command,"SET_CAT") == 0){
			mode = 220;
		}else if(strcmp(m_command,"SET_JAT") == 0){
			mode = 221;
		}else if(strcmp(m_command,"SET_BASE") == 0){
			mode = 222;
		}else if(strcmp(m_command,"SET_TOOL") == 0){
			mode = 223;
		}else if(strcmp(m_command,"SET_CSPD") == 0){
			mode = 224;
		}else if(strcmp(m_command,"SET_JSPD") == 0){
			mode = 225;
		}else if(strcmp(m_command,"SET_CATLIM") == 0){
			mode = 226;
		}else if(strcmp(m_command,"SET_JATLIM") == 0){
			mode = 227;
		}else if(strcmp(m_command,"SET_CSLIM") == 0){
			mode = 228;
		}else if(strcmp(m_command,"SET_COVRD") == 0){
			mode = 229;
		}else if(strcmp(m_command,"SET_JOVRD") == 0){
			mode = 230;
		}else if(strcmp(m_command,"CMVR_ABS") == 0){
			mode = 231;
		}else if(strcmp(m_command,"CMVR_REL") == 0){
			mode = 232;
		}else if(strcmp(m_command,"SET_HOME") == 0){
			mode = 233;
		}else if(strcmp(m_command,"GET_HOME") == 0){
			mode = 234;
		}else if(strcmp(m_command,"GO_HOME") == 0){
			mode = 235;
		}else{
			//Error
			std::cout<<"R}h܂"<<std::endl;
			return RTC::RTC_ERROR;
			
		}
		
	}

	if(mode == 101){
			std::cout<<"C1:A[NA"<<std::endl;

			m_rid=m_ManipulatorCommonInterface_Common->clearAlarms();
			if(m_rid->id == 0){//
				std::cout << "Alarm Clear"<< std::endl;
			}else{//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;
		
		}else if(mode == 102){
			std::cout<<"C2:A[̎擾"<<std::endl;

			JARA_ARM::AlarmSeq_var alarms;

			m_rid=m_ManipulatorCommonInterface_Common->getActiveAlarm(alarms);
			
			if(m_rid->id == 0){//
				m_len=alarms->length();
				if(m_len == 0){
					std::cout << "Non Alarm"<< std::endl;
				}else{
					for(i=0;i<m_len;i++){
						std::cout << "Alarm"<< std::endl << alarms[i].description << std::endl;
					}
				}
			}else{//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;
		
		}else if(mode == 103){
			std::cout<<"C3:֐ߍWn̈ʒutB[hobN̎擾"<<std::endl;

			JARA_ARM::JointPos_var posvar;
			JARA_ARM::JointPos pos;

			m_rid=m_ManipulatorCommonInterface_Common->getFeedbackPosJoint(posvar);
			if(m_rid->id == 0){//
				std::cout << "֐ߍWݒl"<< std::endl;
				pos=posvar;
				m_len=pos.length();
				for(int i=0;i<m_len;i++){
					std::cout << "֐J"<<i+1<<":"<<pos[i]<< std::endl;
				}

			}else{//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;
				
		}else if(mode == 104){
			std::cout<<"C4:}js[^̎擾"<<std::endl;

			JARA_ARM::ManipInfo_var minfovar;
			JARA_ARM::ManipInfo minfo;

			m_rid=m_ManipulatorCommonInterface_Common->getManipInfo(minfovar);
			if(m_rid->id == 0){//
				std::cout << "}js[^"<< std::endl;
				minfo=minfovar;
				std::cout << "[J:"<<minfo.manufactur<< std::endl;
				std::cout << "^Cv:"<<minfo.type<< std::endl;
				std::cout << ":"<<minfo.axisNum<< std::endl;
				std::cout << "[ms]:"<<minfo.cmdCycle<< std::endl;
				std::cout << "1Obp:";
				if(minfo.isGripper) std::cout<<"L"<< std::endl;
				else std::cout<<""<< std::endl;
			}else{//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;
				
		}else if(mode == 105){
			std::cout<<"C5:֐ߍWñ\tg~bgl擾"<<std::endl;

			JARA_ARM::LimitSeq_var limitvar;
			JARA_ARM::LimitSeq limit;

			m_rid=m_ManipulatorCommonInterface_Common->getSoftLimitJoint(limitvar);
			if(m_rid->id == 0){//
				limit=limitvar;
				m_len=limit.length();
				for(int i=0;i<m_len;i++){
					std::cout << "J"<<i+1<<",Lower:"<<limit[i].lower<< std::endl<<"  ,Upper:"<<limit[i].upper<< std::endl;
				}

			}else{//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;
				
		}else if(mode == 106){
			std::cout<<"C6:jbg̏Ԏ擾"<<std::endl;

			ULONG state;

			m_rid=m_ManipulatorCommonInterface_Common->getState(state);
			if(m_rid->id == 0){//
				if(state&0x1) std::cout <<"T[{nm"<< std::endl;
				if(state&0x2) std::cout <<"쒆"<< std::endl;
				if(state&0x4) std::cout <<"A["<< std::endl;
				if(state&0x8) std::cout <<"Move߂̃obt@t"<< std::endl;

			}else{//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;
					
		}else if(mode == 107){
			std::cout<<"C7:ST[{OFF"<<std::endl;

			m_rid=m_ManipulatorCommonInterface_Common->servoOFF();
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;
				
		}else if(mode == 108){
			std::cout<<"C8:ST[{ON"<<std::endl;

			m_rid=m_ManipulatorCommonInterface_Common->servoON();
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;
				
		}else if(mode == 109){
			std::cout<<"C9:֐ߍWñ\tg~bglݒ"<<std::endl;

			JARA_ARM::ManipInfo_var minfovar;
			JARA_ARM::ManipInfo minfo;
			JARA_ARM::LimitSeq softLimit;

			m_rid=m_ManipulatorCommonInterface_Common->getManipInfo(minfovar);
			minfo=minfovar;
			m_len=minfo.axisNum;
			softLimit.length(minfo.axisNum);
			
			if( c == 'm' ){

				if(m_len <= 3){
					//cin͂m_Bufւ̑
					std::cout<<"l"<<std::endl;
					for(i=0;i<m_len;i++){
						std::cout<<"Angle"<<i+1<<" : [mm]"<<std::endl;
						std::cin>>m_Buf[2*i];
					}
					std::cout<<"l"<<std::endl;
					for(i=0;i<m_len;i++){
						std::cout<<"Angle"<<i+1<<" : [mm]"<<std::endl;
						std::cin>>m_Buf[2*i+1];
					}
				}else{
					//cin͂m_Bufւ̑
					std::cout<<"l"<<std::endl;
					for(i=0;i<m_len;i++){
						std::cout<<"Angle"<<i+1<<" : [deg]"<<std::endl;
						std::cin>>m_Buf[2*i];
					}
					std::cout<<"l"<<std::endl;
					for(i=0;i<m_len;i++){
						std::cout<<"Angle"<<i+1<<" : [deg]"<<std::endl;
						std::cin>>m_Buf[2*i+1];
					}
				}
				
			}

			if(m_len <= 3){
				for(i=0;i<m_len;i++){
					m_Buf[2*i] = m_Buf[2*i]/1000.0;//[mm]->[m]
					m_Buf[2*i+1] = m_Buf[2*i+1]/1000.0;//[mm]->[m]
				}
			}else{
				m_Buf[2*i] = m_Buf[2*i]*m_PI/180.0;//[deg]->[rad]
				m_Buf[2*i+1] = m_Buf[2*i+1]*m_PI/180.0;//[deg]->[rad]
			}

			for(i=0;i<m_len;i++){
				softLimit[i].lower=m_Buf[2*i];
				softLimit[i].upper=m_Buf[2*i+1];
			}

			m_rid=m_ManipulatorCommonInterface_Common->setSoftLimitJoint(softLimit);


			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;
				
		}else if(mode == 201){
			std::cout<<"M1:Obp"<<std::endl;

			m_rid=m_ManipulatorCommonInterface_Middle->closeGripper();
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;

			do{
				m_ManipulatorCommonInterface_Common->getState(m_state);
				if(m_state&0x4){
					std::cout <<"A["<< std::endl;
					RTC_ERROR(("A["));
					return RTC::RTC_ERROR;
				}
			}while(m_state&0x2);
				
		}else if(mode == 202){
			std::cout<<"M2:}js[^̐ݒʒu擾"<<std::endl;

			JARA_ARM::HgMatrix offset;

			m_rid=m_ManipulatorCommonInterface_Middle->getBaseOffset(offset);

			if(m_rid->id == 0){//
				
				m_Buf[0]=offset[0][3]*1000.0;//[m]->[mm]
				m_Buf[1]=offset[1][3]*1000.0;//[m]->[mm]
				m_Buf[2]=offset[2][3]*1000.0;//[m]->[mm]

				m_Buf[4]=asin(-offset[0][2])*180.0/m_PI;
				if(fabs(m_Buf[4]) != 90){
					m_Buf[3]=atan(offset[1][2]/offset[2][2])*180.0/m_PI;
					m_Buf[5]=atan(offset[0][1]/offset[0][0])*180.0/m_PI;
				}else{
					m_Buf[3]=0.0;
					m_Buf[5]=atan(offset[1][1]/offset[0][1])*180.0/m_PI;
				}
				
				std::cout <<"xW:"<<m_Buf[0]<<"[mm]"<< std::endl;
				std::cout <<"yW:"<<m_Buf[1]<<"[mm]"<< std::endl;
				std::cout <<"zW:"<<m_Buf[2]<<"[mm]"<< std::endl;
				std::cout <<"x]:"<<m_Buf[3]<<"[deg]"<< std::endl;
				std::cout <<"y]:"<<m_Buf[4]<<"[deg]"<< std::endl;
				std::cout <<"z]:"<<m_Buf[5]<<"[deg]"<< std::endl;

			}else{//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;
				
		}else if(mode == 203){
			std::cout<<"M3:Wn̈ʒutB[hobN̎擾"<<std::endl;

			JARA_ARM::CarPosWithElbow pos;

			m_rid=m_ManipulatorCommonInterface_Middle->getFeedbackPosCartesian(pos);
			if(m_rid->id == 0){//
				m_Buf[0]=pos.carPos[0][3]*1000.0;//[m]->[mm]
				m_Buf[1]=pos.carPos[1][3]*1000.0;//[m]->[mm]
				m_Buf[2]=pos.carPos[2][3]*1000.0;//[m]->[mm]

				m_Buf[4]=asin(-pos.carPos[0][2])*180.0/m_PI;
				if(fabs(m_Buf[4]) != 90){
					m_Buf[3]=atan(pos.carPos[1][2]/pos.carPos[2][2])*180.0/m_PI;
					m_Buf[5]=atan(pos.carPos[0][1]/pos.carPos[0][0])*180.0/m_PI;
				}else{
					m_Buf[3]=0.0;
					m_Buf[5]=atan(pos.carPos[1][1]/pos.carPos[0][1])*180.0/m_PI;
				}
				
				std::cout <<"xW:"<<m_Buf[0]<<"[mm]"<< std::endl;
				std::cout <<"yW:"<<m_Buf[1]<<"[mm]"<< std::endl;
				std::cout <<"zW:"<<m_Buf[2]<<"[mm]"<< std::endl;
				std::cout <<"x]:"<<m_Buf[3]<<"[deg]"<< std::endl;
				std::cout <<"y]:"<<m_Buf[4]<<"[deg]"<< std::endl;
				std::cout <<"z]:"<<m_Buf[5]<<"[deg]"<< std::endl;

			}else{//Error
				std::cout << std::endl<< m_rid->comment << std::endl;/*****************************************/
			}
			std::cout<<std::endl;
				
		}else if(mode == 204){
			std::cout<<"M4:𓮍쎞̍ő哮쑬x擾"<<std::endl;

			JARA_ARM::CartesianSpeed_var speedvar;
			JARA_ARM::CartesianSpeed speed;

			m_rid=m_ManipulatorCommonInterface_Middle->getMaxSpeedCartesian(speedvar);
			if(m_rid->id == 0){//
				speed=speedvar;

				std::cout <<"őix:"<<speed.translation<<"[m/s]"<< std::endl;
				std::cout <<"ő]x:"<<speed.rotation<<"[rad/s]"<< std::endl;

			}else{//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
			}
			std::cout<<std::endl;
		
		}else if(mode == 205){
			std::cout<<"M5:֐ߓ쎞̍ő哮쑬x擾"<<std::endl;

			JARA_ARM::DoubleSeq_var speedvar;
			JARA_ARM::DoubleSeq speed;

			m_rid=m_ManipulatorCommonInterface_Middle->getMaxSpeedJoint(speedvar);
			if(m_rid->id == 0){//
				speed=speedvar;
				m_len=speed.length();
				std::cout<<"ő哮쑬x"<<std::endl;
				for(int i=0;i<m_len;i++){			
					std::cout <<"֐["<<i+1<<"]:"<<speed[i]<<"[rad/s]"<< std::endl;
				}
				

			}else{//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
			}
			std::cout<<std::endl;
				
		}else if(mode == 206){
			std::cout<<"M6:𓮍쎞̍ŏԂ擾"<<std::endl;

			double time;

			m_rid=m_ManipulatorCommonInterface_Middle->getMinAccelTimeCartesian(time);
			if(m_rid->id == 0){//
				std::cout << "ŏ"<<time<<"[s]"<< std::endl;

			}else{//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
			}
			std::cout<<std::endl;
				
		}else if(mode == 207){
			std::cout<<"M7:֐ߓ쎞̍ŏԂ擾"<<std::endl;

			double time;

			m_rid=m_ManipulatorCommonInterface_Middle->getMinAccelTimeJoint(time);
			if(m_rid->id == 0){//
				std::cout << "ŏ"<<time<<"[s]"<< std::endl;

			}else{//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
			}
			std::cout<<std::endl;
			
		}else if(mode == 208){
			std::cout<<"M8:Wñ\tg~bgl擾"<<std::endl;

			JARA_ARM::LimitValue limit[3];

			m_rid=m_ManipulatorCommonInterface_Middle->getSoftLimitCartesian(limit[0],limit[1],limit[2]);
			if(m_rid->id == 0){//
				std::cout << "xW:"<<limit[0].lower*1000.0<<"[mm]"<< std::endl;
				std::cout << " @@:"<<limit[0].upper*1000.0<<"[mm]"<< std::endl;
				std::cout << "yW:"<<limit[1].lower*1000.0<<"[mm]"<< std::endl;
				std::cout << " @@:"<<limit[1].upper*1000.0<<"[mm]"<< std::endl;
				std::cout << "zW:"<<limit[2].lower*1000.0<<"[mm]"<< std::endl;
				std::cout << " @@:"<<limit[2].upper*1000.0<<"[mm]"<< std::endl;

			}else{//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
			}
			std::cout<<std::endl;
				
		}else if(mode == 209){
			std::cout<<"M9:Obp̊J"<<std::endl;

			if( c == 'm' ){
				//cin͂m_Bufւ̑
				std::cout << "nhJ[%]"<< std::endl;
				std::cin>>m_Buf[0];
			}

			ULONG rate;

			rate=m_Buf[0];

			m_rid=m_ManipulatorCommonInterface_Middle->moveGripper(rate);
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;

			do{
				m_ManipulatorCommonInterface_Common->getState(m_state);
				if(m_state&0x4){
					std::cout <<"A["<< std::endl;
					RTC_ERROR(("A["));
					return RTC::RTC_ERROR;
				}
			}while(m_state&0x2);

		}else if(mode == 210){
			std::cout<<"M10:Wn̒(Ύw)"<<std::endl;

			if( c == 'm' ){
				//cin͂m_Bufւ̑
				std::cout<<"ʒuW:x[mm]"<<std::endl;
				std::cin>>m_Buf[0];
				std::cout<<"ʒuW:y[mm]"<<std::endl;
				std::cin>>m_Buf[1];
				std::cout<<"ʒuW:z[mm]"<<std::endl;
				std::cin>>m_Buf[2];
				std::cout<<"ppx:A[deg]"<<std::endl;
				std::cin>>m_Buf[3];
				std::cout<<"ppx:B[deg]"<<std::endl;
				std::cin>>m_Buf[4];
				std::cout<<"ppx:C[deg]"<<std::endl;
				std::cin>>m_Buf[5];

			}

			m_Buf[0] = m_Buf[0]/1000.0;//[mm]->[m]
			m_Buf[1] = m_Buf[1]/1000.0;//[mm]->[m]
			m_Buf[2] = m_Buf[2]/1000.0;//[mm]->[m]

			JARA_ARM::CarPosWithElbow pos;

			//deg->redϊ
			m_Buf[3]=m_Buf[3]/180.0*m_PI;
			m_Buf[4]=m_Buf[4]/180.0*m_PI;
			m_Buf[5]=m_Buf[5]/180.0*m_PI;

			//pX->Y->Z]ł̒l
			//1
			pos.carPos[0][0]=cos(m_Buf[5])*cos(m_Buf[4]);
			pos.carPos[1][0]=sin(m_Buf[5])*cos(m_Buf[4]);
			pos.carPos[2][0]=-sin(m_Buf[4]);
			
			//2
			pos.carPos[0][1]=-sin(m_Buf[5])*cos(m_Buf[3])+cos(m_Buf[5])*sin(m_Buf[4])*sin(m_Buf[3]);
			pos.carPos[1][1]=cos(m_Buf[5])*cos(m_Buf[3])+sin(m_Buf[5])*sin(m_Buf[4])*sin(m_Buf[3]);
			pos.carPos[2][1]=cos(m_Buf[4])*sin(m_Buf[3]);
			
			//3
			pos.carPos[0][2]=sin(m_Buf[5])*sin(m_Buf[3])+cos(m_Buf[5])*sin(m_Buf[4])*cos(m_Buf[3]);
			pos.carPos[1][2]=-cos(m_Buf[5])*sin(m_Buf[3])+sin(m_Buf[5])*sin(m_Buf[4])*cos(m_Buf[3]);
			pos.carPos[2][2]=cos(m_Buf[4])*cos(m_Buf[3]);
			
			//4
			pos.carPos[0][3]=m_Buf[0];
			pos.carPos[1][3]=m_Buf[1];
			pos.carPos[2][3]=m_Buf[2];
			
			m_rid=m_ManipulatorCommonInterface_Middle->moveLinearCartesianAbs(pos);
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;

			do{
				m_ManipulatorCommonInterface_Common->getState(m_state);
				if(m_state&0x4){
					std::cout <<"A["<< std::endl;
					RTC_ERROR(("A["));
					return RTC::RTC_ERROR;
				}
			}while(m_state&0x2);
			
		}else if(mode == 211){
			std::cout<<"M11:Wn̒(Ύw)"<<std::endl;

			if( c == 'm' ){
				//cin͂m_Bufւ̑
				std::cout<<"ʒuW:x[mm]"<<std::endl;
				std::cin>>m_Buf[0];
				std::cout<<"ʒuW:y[mm]"<<std::endl;
				std::cin>>m_Buf[1];
				std::cout<<"ʒuW:z[mm]"<<std::endl;
				std::cin>>m_Buf[2];
				std::cout<<"ppx:A[deg]"<<std::endl;
				std::cin>>m_Buf[3];
				std::cout<<"ppx:B[deg]"<<std::endl;
				std::cin>>m_Buf[4];
				std::cout<<"ppx:C[deg]"<<std::endl;
				std::cin>>m_Buf[5];
			}

			m_Buf[0] = m_Buf[0]/1000.0;//[mm]->[m]
			m_Buf[1] = m_Buf[1]/1000.0;//[mm]->[m]
			m_Buf[2] = m_Buf[2]/1000.0;//[mm]->[m]

			JARA_ARM::CarPosWithElbow pos;

			//deg->redϊ
			m_Buf[3]=m_Buf[3]/180.0*m_PI;
			m_Buf[4]=m_Buf[4]/180.0*m_PI;
			m_Buf[5]=m_Buf[5]/180.0*m_PI;

			//pX->Y->Z]ł̒l
			//1
			pos.carPos[0][0]=cos(m_Buf[5])*cos(m_Buf[4]);
			pos.carPos[1][0]=sin(m_Buf[5])*cos(m_Buf[4]);
			pos.carPos[2][0]=-sin(m_Buf[4]);
			
			//2
			pos.carPos[0][1]=-sin(m_Buf[5])*cos(m_Buf[3])+cos(m_Buf[5])*sin(m_Buf[4])*sin(m_Buf[3]);
			pos.carPos[1][1]=cos(m_Buf[5])*cos(m_Buf[3])+sin(m_Buf[5])*sin(m_Buf[4])*sin(m_Buf[3]);
			pos.carPos[2][1]=cos(m_Buf[4])*sin(m_Buf[3]);
			
			//3
			pos.carPos[0][2]=sin(m_Buf[5])*sin(m_Buf[3])+cos(m_Buf[5])*sin(m_Buf[4])*cos(m_Buf[3]);
			pos.carPos[1][2]=-cos(m_Buf[5])*sin(m_Buf[3])+sin(m_Buf[5])*sin(m_Buf[4])*cos(m_Buf[3]);
			pos.carPos[2][2]=cos(m_Buf[4])*cos(m_Buf[3]);
			
			//4
			pos.carPos[0][3]=m_Buf[0];
			pos.carPos[1][3]=m_Buf[1];
			pos.carPos[2][3]=m_Buf[2];
			
			m_rid=m_ManipulatorCommonInterface_Middle->moveLinearCartesianRel(pos);
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;

			do{
				m_ManipulatorCommonInterface_Common->getState(m_state);
				if(m_state&0x4){
					std::cout <<"A["<< std::endl;
					RTC_ERROR(("A["));
					return RTC::RTC_ERROR;
				}
			}while(m_state&0x2);

		}else if(mode == 212){
			std::cout<<"M12:֐ߍWn̒(EΎw)"<<std::endl;

			if( c == 'm' ){
				//cin͂m_Bufւ̑
				std::cout<<"ʒuW:x[mm]"<<std::endl;
				std::cin>>m_Buf[0];
				std::cout<<"ʒuW:y[mm]"<<std::endl;
				std::cin>>m_Buf[1];
				std::cout<<"ʒuW:z[mm]"<<std::endl;
				std::cin>>m_Buf[2];
				std::cout<<"ppx:A[deg]"<<std::endl;
				std::cin>>m_Buf[3];
				std::cout<<"ppx:B[deg]"<<std::endl;
				std::cin>>m_Buf[4];
				std::cout<<"ppx:C[deg]"<<std::endl;
				std::cin>>m_Buf[5];
			}

			m_Buf[0] = m_Buf[0]/1000.0;//[mm]->[m]
			m_Buf[1] = m_Buf[1]/1000.0;//[mm]->[m]
			m_Buf[2] = m_Buf[2]/1000.0;//[mm]->[m]

			JARA_ARM::CarPosWithElbow pos;

			//deg->redϊ
			m_Buf[3]=m_Buf[3]/180.0*m_PI;
			m_Buf[4]=m_Buf[4]/180.0*m_PI;
			m_Buf[5]=m_Buf[5]/180.0*m_PI;

			//pX->Y->Z]ł̒l
			//1
			pos.carPos[0][0]=cos(m_Buf[5])*cos(m_Buf[4]);
			pos.carPos[1][0]=sin(m_Buf[5])*cos(m_Buf[4]);
			pos.carPos[2][0]=-sin(m_Buf[4]);
			
			//2
			pos.carPos[0][1]=-sin(m_Buf[5])*cos(m_Buf[3])+cos(m_Buf[5])*sin(m_Buf[4])*sin(m_Buf[3]);
			pos.carPos[1][1]=cos(m_Buf[5])*cos(m_Buf[3])+sin(m_Buf[5])*sin(m_Buf[4])*sin(m_Buf[3]);
			pos.carPos[2][1]=cos(m_Buf[4])*sin(m_Buf[3]);
			
			//3
			pos.carPos[0][2]=sin(m_Buf[5])*sin(m_Buf[3])+cos(m_Buf[5])*sin(m_Buf[4])*cos(m_Buf[3]);
			pos.carPos[1][2]=-cos(m_Buf[5])*sin(m_Buf[3])+sin(m_Buf[5])*sin(m_Buf[4])*cos(m_Buf[3]);
			pos.carPos[2][2]=cos(m_Buf[4])*cos(m_Buf[3]);
			
			//4
			pos.carPos[0][3]=m_Buf[0];
			pos.carPos[1][3]=m_Buf[1];
			pos.carPos[2][3]=m_Buf[2];
			
			m_rid=m_ManipulatorCommonInterface_Middle->movePTPCartesianAbs(pos);
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;

			do{
				m_ManipulatorCommonInterface_Common->getState(m_state);
				if(m_state&0x4){
					std::cout <<"A["<< std::endl;
					RTC_ERROR(("A["));
					return RTC::RTC_ERROR;
				}
			}while(m_state&0x2);

		}else if(mode == 213){
			std::cout<<"M13:֐ߍWn̒(EΎw)"<<std::endl;

			if( c == 'm' ){
				//cin͂m_Bufւ̑
				std::cout<<"ʒuW:x[mm]"<<std::endl;
				std::cin>>m_Buf[0];
				std::cout<<"ʒuW:y[mm]"<<std::endl;
				std::cin>>m_Buf[1];
				std::cout<<"ʒuW:z[mm]"<<std::endl;
				std::cin>>m_Buf[2];
				std::cout<<"ppx:A[deg]"<<std::endl;
				std::cin>>m_Buf[3];
				std::cout<<"ppx:B[deg]"<<std::endl;
				std::cin>>m_Buf[4];
				std::cout<<"ppx:C[deg]"<<std::endl;
				std::cin>>m_Buf[5];
			}

			m_Buf[0] = m_Buf[0]/1000.0;//[mm]->[m]
			m_Buf[1] = m_Buf[1]/1000.0;//[mm]->[m]
			m_Buf[2] = m_Buf[2]/1000.0;//[mm]->[m]
			
			JARA_ARM::CarPosWithElbow pos;

			//deg->redϊ
			m_Buf[3]=m_Buf[3]/180.0*m_PI;
			m_Buf[4]=m_Buf[4]/180.0*m_PI;
			m_Buf[5]=m_Buf[5]/180.0*m_PI;

			//pX->Y->Z]ł̒l
			//1
			pos.carPos[0][0]=cos(m_Buf[5])*cos(m_Buf[4]);
			pos.carPos[1][0]=sin(m_Buf[5])*cos(m_Buf[4]);
			pos.carPos[2][0]=-sin(m_Buf[4]);
			
			//2
			pos.carPos[0][1]=-sin(m_Buf[5])*cos(m_Buf[3])+cos(m_Buf[5])*sin(m_Buf[4])*sin(m_Buf[3]);
			pos.carPos[1][1]=cos(m_Buf[5])*cos(m_Buf[3])+sin(m_Buf[5])*sin(m_Buf[4])*sin(m_Buf[3]);
			pos.carPos[2][1]=cos(m_Buf[4])*sin(m_Buf[3]);
			
			//3
			pos.carPos[0][2]=sin(m_Buf[5])*sin(m_Buf[3])+cos(m_Buf[5])*sin(m_Buf[4])*cos(m_Buf[3]);
			pos.carPos[1][2]=-cos(m_Buf[5])*sin(m_Buf[3])+sin(m_Buf[5])*sin(m_Buf[4])*cos(m_Buf[3]);
			pos.carPos[2][2]=cos(m_Buf[4])*cos(m_Buf[3]);
			
			//4
			pos.carPos[0][3]=m_Buf[0];
			pos.carPos[1][3]=m_Buf[1];
			pos.carPos[2][3]=m_Buf[2];
			
			m_rid=m_ManipulatorCommonInterface_Middle->movePTPCartesianRel(pos);
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;

			do{
				m_ManipulatorCommonInterface_Common->getState(m_state);
				if(m_state&0x4){
					std::cout <<"A["<< std::endl;
					RTC_ERROR(("A["));
					return RTC::RTC_ERROR;
				}
			}while(m_state&0x2);

		}else if(mode == 214){
			std::cout<<"M14:֐ߍWn̒(֐߁EΎw)"<<std::endl;

			JARA_ARM::ManipInfo_var minfovar;
			JARA_ARM::ManipInfo minfo;
			JARA_ARM::JointPos jnt;

			m_rid=m_ManipulatorCommonInterface_Common->getManipInfo(minfovar);
			minfo=minfovar;
			m_len=minfo.axisNum;
			jnt.length(m_len);

			if( c == 'm' ){
				if(m_len <= 3){
					//cin͂m_Bufւ̑
					std::cout<<"ڕW֐ߒl[mm]"<<std::endl;
					for(i=0;i<m_len;i++){			
						std::cout <<"֐["<<i+1<<"]"<< std::endl;
						std::cin>>m_Buf[i];
					}
				}else{
					//cin͂m_Bufւ̑
					std::cout<<"ڕW֐ߊp[deg]"<<std::endl;
					for(i=0;i<m_len;i++){			
						std::cout <<"֐["<<i+1<<"]"<< std::endl;
						std::cin>>m_Buf[i];
					}
				}
			}

			if(m_len <= 3){
				for(int i=0;i<m_len;i++){			
					jnt[i]=m_Buf[i]/1000.0;//[mm]->[m]
				}
			}else{
				for(int i=0;i<m_len;i++){			
					jnt[i]=m_Buf[i]*m_PI/180.0;//[deg]->[rad]
				}
			}

			m_rid=m_ManipulatorCommonInterface_Middle->movePTPJointAbs(jnt);
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;

			do{
				m_ManipulatorCommonInterface_Common->getState(m_state);
				if(m_state&0x4){
					std::cout <<"A["<< std::endl;
					RTC_ERROR(("A["));
					return RTC::RTC_ERROR;
				}
			}while(m_state&0x2);

		}else if(mode == 215){
			std::cout<<"M15:֐ߍWn̒(֐߁EΎw)"<<std::endl;
				
			JARA_ARM::ManipInfo_var minfovar;
			JARA_ARM::ManipInfo minfo;
			JARA_ARM::JointPos jnt;

			m_rid=m_ManipulatorCommonInterface_Common->getManipInfo(minfovar);
			minfo=minfovar;
			m_len=minfo.axisNum;
			jnt.length(m_len);

			if( c == 'm' ){
				if(m_len <= 3){
					//cin͂m_Bufւ̑
					std::cout<<"ڕW֐ߒl[mm]"<<std::endl;
					for(i=0;i<m_len;i++){			
						std::cout <<"֐["<<i+1<<"]"<< std::endl;
						std::cin>>m_Buf[i];
					}
				}else{
					//cin͂m_Bufւ̑
					std::cout<<"ڕW֐ߊp[deg]"<<std::endl;
					for(i=0;i<m_len;i++){			
						std::cout <<"֐["<<i+1<<"]"<< std::endl;
						std::cin>>m_Buf[i];
					}
				}
			}

			if(m_len <= 3){
				for(int i=0;i<m_len;i++){			
					jnt[i]=m_Buf[i]/1000.0;//[mm]->[m]
				}
			}else{
				for(int i=0;i<m_len;i++){			
					jnt[i]=m_Buf[i]*m_PI/180.0;//[deg]->[rad]
				}
			}

			m_rid=m_ManipulatorCommonInterface_Middle->movePTPJointRel(jnt);
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;

			do{
				m_ManipulatorCommonInterface_Common->getState(m_state);
				if(m_state&0x4){
					std::cout <<"A["<< std::endl;
					RTC_ERROR(("A["));
					return RTC::RTC_ERROR;
				}
			}while(m_state&0x2);

		}else if(mode == 216){
			std::cout<<"M16:ObpJ"<<std::endl;

			m_rid=m_ManipulatorCommonInterface_Middle->openGripper();
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;

			do{
				m_ManipulatorCommonInterface_Common->getState(m_state);
				if(m_state&0x4){
					std::cout <<"A["<< std::endl;
					RTC_ERROR(("A["));
					return RTC::RTC_ERROR;
				}
			}while(m_state&0x2);
				
		}else if(mode == 217){
			std::cout<<"M17:̈ꎞ~"<<std::endl;

			m_rid=m_ManipulatorCommonInterface_Middle->pause();
			if(m_rid->id == 0){//
				std::cout << "ꎞ~܂"<< std::endl;
			}else{//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
			}
			std::cout<<std::endl;
				
		}else if(mode == 218){
			std::cout<<"M18:̍ĊJ"<<std::endl;

			m_rid=m_ManipulatorCommonInterface_Middle->resume();
			if(m_rid->id == 0){//
				std::cout << "ĊJ܂"<< std::endl;
			}else{//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
			}
			std::cout<<std::endl;
				
		}else if(mode == 219){
			std::cout<<"M19:̒~"<<std::endl;

			m_rid=m_ManipulatorCommonInterface_Middle->stop();
			if(m_rid->id == 0){//
				std::cout << "~܂"<< std::endl;
			}else{//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
			}
			std::cout<<std::endl;
		
		}else if(mode == 220){
			std::cout<<"M20:𓮍쎞̉Ԃݒ"<<std::endl;

			if( c == 'm' ){
				//cin͂m_Bufւ̑
				std::cout<<"[s]"<<std::endl;
				std::cin>>m_Buf[0];
			}

			double time;

			time=m_Buf[0];

			m_rid=m_ManipulatorCommonInterface_Middle->setMinAccelTimeCartesian(time);
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;
				
				
		}else if(mode == 221){
			std::cout<<"21:֐ߓ쎞̉Ԃݒ"<<std::endl;

			if( c == 'm' ){
				//cin͂m_Bufւ̑
				std::cout<<"[s]"<<std::endl;
				std::cin>>m_Buf[0];
			}

			double time;

			time=m_Buf[0];

			m_rid=m_ManipulatorCommonInterface_Middle->setMinAccelTimeJoint(time);
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;

		}else if(mode == 222){
			std::cout<<"M22:}js[^̐ݒuʒuݒ"<<std::endl;

			if( c == 'm' ){
				//cin͂m_Bufւ̑
				std::cout<<"ʒuW:x[mm]"<<std::endl;
				std::cin>>m_Buf[0];
				std::cout<<"ʒuW:y[mm]"<<std::endl;
				std::cin>>m_Buf[1];
				std::cout<<"ʒuW:z[mm]"<<std::endl;
				std::cin>>m_Buf[2];
				std::cout<<"ppx:A[deg]"<<std::endl;
				std::cin>>m_Buf[3];
				std::cout<<"ppx:B[deg]"<<std::endl;
				std::cin>>m_Buf[4];
				std::cout<<"ppx:C[deg]"<<std::endl;
				std::cin>>m_Buf[5];
			}

			m_Buf[0] = m_Buf[0]/1000.0;//[mm]->[m]
			m_Buf[1] = m_Buf[1]/1000.0;//[mm]->[m]
			m_Buf[2] = m_Buf[2]/1000.0;//[mm]->[m]

			JARA_ARM::HgMatrix offset;

			//deg->redϊ
			m_Buf[3]=m_Buf[3]/180.0*m_PI;
			m_Buf[4]=m_Buf[4]/180.0*m_PI;
			m_Buf[5]=m_Buf[5]/180.0*m_PI;

			//pX->Y->Z]ł̒l
			//1
			offset[0][0]=cos(m_Buf[5])*cos(m_Buf[4]);
			offset[1][0]=sin(m_Buf[5])*cos(m_Buf[4]);
			offset[2][0]=-sin(m_Buf[4]);
			
			//2
			offset[0][1]=-sin(m_Buf[5])*cos(m_Buf[3])+cos(m_Buf[5])*sin(m_Buf[4])*sin(m_Buf[3]);
			offset[1][1]=cos(m_Buf[5])*cos(m_Buf[3])+sin(m_Buf[5])*sin(m_Buf[4])*sin(m_Buf[3]);
			offset[2][1]=cos(m_Buf[4])*sin(m_Buf[3]);
			
			//3
			offset[0][2]=sin(m_Buf[5])*sin(m_Buf[3])+cos(m_Buf[5])*sin(m_Buf[4])*cos(m_Buf[3]);
			offset[1][2]=-cos(m_Buf[5])*sin(m_Buf[3])+sin(m_Buf[5])*sin(m_Buf[4])*cos(m_Buf[3]);
			offset[2][2]=cos(m_Buf[4])*cos(m_Buf[3]);
			
			//4
			offset[0][3]=m_Buf[0];
			offset[1][3]=m_Buf[1];
			offset[2][3]=m_Buf[2];

			m_rid=m_ManipulatorCommonInterface_Middle->setBaseOffset(offset);
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;

				
		}else if(mode == 223){
			std::cout<<"M23:_̃tWʂ̃ItZbgʂݒ"<<std::endl;

			if( c == 'm' ){
				//cin͂m_Bufւ̑
				std::cout<<"ʒuW:x[mm]"<<std::endl;
				std::cin>>m_Buf[0];
				std::cout<<"ʒuW:y[mm]"<<std::endl;
				std::cin>>m_Buf[1];
				std::cout<<"ʒuW:z[mm]"<<std::endl;
				std::cin>>m_Buf[2];
				std::cout<<"ppx:A[deg]"<<std::endl;
				std::cin>>m_Buf[3];
				std::cout<<"ppx:B[deg]"<<std::endl;
				std::cin>>m_Buf[4];
				std::cout<<"ppx:C[deg]"<<std::endl;
				std::cin>>m_Buf[5];
			}

			m_Buf[0] = m_Buf[0]/1000.0;//[mm]->[m]
			m_Buf[1] = m_Buf[1]/1000.0;//[mm]->[m]
			m_Buf[2] = m_Buf[2]/1000.0;//[mm]->[m]

			JARA_ARM::HgMatrix offset;

			//deg->redϊ
			m_Buf[3]=m_Buf[3]/180.0*m_PI;
			m_Buf[4]=m_Buf[4]/180.0*m_PI;
			m_Buf[5]=m_Buf[5]/180.0*m_PI;

			//pX->Y->Z]ł̒l
			//1
			offset[0][0]=cos(m_Buf[5])*cos(m_Buf[4]);
			offset[1][0]=sin(m_Buf[5])*cos(m_Buf[4]);
			offset[2][0]=-sin(m_Buf[4]);
			
			//2
			offset[0][1]=-sin(m_Buf[5])*cos(m_Buf[3])+cos(m_Buf[5])*sin(m_Buf[4])*sin(m_Buf[3]);
			offset[1][1]=cos(m_Buf[5])*cos(m_Buf[3])+sin(m_Buf[5])*sin(m_Buf[4])*sin(m_Buf[3]);
			offset[2][1]=cos(m_Buf[4])*sin(m_Buf[3]);
			
			//3
			offset[0][2]=sin(m_Buf[5])*sin(m_Buf[3])+cos(m_Buf[5])*sin(m_Buf[4])*cos(m_Buf[3]);
			offset[1][2]=-cos(m_Buf[5])*sin(m_Buf[3])+sin(m_Buf[5])*sin(m_Buf[4])*cos(m_Buf[3]);
			offset[2][2]=cos(m_Buf[4])*cos(m_Buf[3]);
			
			//4
			offset[0][3]=m_Buf[0];
			offset[1][3]=m_Buf[1];
			offset[2][3]=m_Buf[2];

			m_rid=m_ManipulatorCommonInterface_Middle->setControlPointOffset(offset);
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;

		}else if(mode == 224){
			std::cout<<"M24:𓮍쎞̍ő哮쑬xݒ"<<std::endl;

			if( c == 'm' ){
				//cin͂m_Bufւ̑
				std::cout<<"őix[m/s]"<<std::endl;
				std::cin>>m_Buf[0];
			
				std::cout<<"ő]x[rad/s]"<<std::endl;
				std::cin>>m_Buf[1];
			}
			
			JARA_ARM::CartesianSpeed speed;

			speed.translation=m_Buf[0];
			speed.rotation=m_Buf[1];

			m_rid=m_ManipulatorCommonInterface_Middle->setMaxSpeedCartesian(speed);
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;

		}else if(mode == 225){
			std::cout<<"M25:֐ߓ쎞̍ő哮쑬xݒ"<<std::endl;
				
			JARA_ARM::DoubleSeq speed;
			JARA_ARM::ManipInfo_var minfovar;
			JARA_ARM::ManipInfo minfo;

			m_rid=m_ManipulatorCommonInterface_Common->getManipInfo(minfovar);
			minfo=minfovar;
			m_len=minfo.axisNum;
			speed.length(m_len);

			if( c == 'm' ){
				//cin͂m_Bufւ̑
				std::cout<<"ő֐ߑx"<<std::endl;
				for(i=0;i<m_len;i++){
					std::cout<<"֐"<<i+1<<std::endl;
					std::cin>>m_Buf[i];
				}
			}

			for(i=0;i<m_len;i++){
				speed[i]=m_Buf[i];
			}

			m_rid=m_ManipulatorCommonInterface_Middle->setMaxSpeedJoint(speed);
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;

		}else if(mode == 226){
			std::cout<<"M26:𓮍쎞̍ŏԂݒ"<<std::endl;

			if( c == 'm' ){
				//cin͂m_Bufւ̑
				std::cout<<"ŏ[s]"<<std::endl;
				std::cin>>m_Buf[0];
			}
			
			double time;

			time=m_Buf[0];

			m_rid=m_ManipulatorCommonInterface_Middle->setMinAccelTimeCartesian(time);
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;

		}else if(mode == 227){
			std::cout<<"M27:֐ߓ쎞̍ŏԂݒ"<<std::endl;

			if( c == 'm' ){
				//cin͂m_Bufւ̑
				std::cout<<"ŏ[s]"<<std::endl;
				std::cin>>m_Buf[0];
			}

			double time;

			time=m_Buf[0];

			m_rid=m_ManipulatorCommonInterface_Middle->setMinAccelTimeJoint(time);
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;

		}else if(mode == 228){
			std::cout<<"M28:Wñ\tg~bglݒ"<<std::endl;

			if( c == 'm' ){
				//cin͂m_Bufւ̑
				std::cout<<"l"<<std::endl;
				std::cout<<"xW[mm]"<<std::endl;
				std::cin>>m_Buf[0];
				std::cout<<"yW[mm]"<<std::endl;
				std::cin>>m_Buf[2];
				std::cout<<"zW[mm]"<<std::endl;
				std::cin>>m_Buf[4];
				std::cout<<"l"<<std::endl;
				std::cout<<"xW[mm]"<<std::endl;
				std::cin>>m_Buf[1];
				std::cout<<"yW[mm]"<<std::endl;
				std::cin>>m_Buf[3];
				std::cout<<"zW[mm]"<<std::endl;
				std::cin>>m_Buf[5];
			}

			for(int i=0; i<6 ;i++){
				m_Buf[i]=m_Buf[i]/1000.0;//[mm]->[m]
			}

			JARA_ARM::LimitValue limit[3];

			limit[0].lower=m_Buf[0];
			limit[0].upper=m_Buf[1];
			limit[1].lower=m_Buf[2];
			limit[1].upper=m_Buf[3];
			limit[2].lower=m_Buf[4];
			limit[2].upper=m_Buf[5];
				
			m_rid=m_ManipulatorCommonInterface_Middle->setSoftLimitCartesian(limit[0],limit[1],limit[2]);
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;

		}else if(mode == 229){
			std::cout<<"M29:𓮍쎞̑xݒ"<<std::endl;

			if( c == 'm' ){
				//cin͂m_Bufւ̑
				std::cout<<"ő哮쎞ɑ΂銄[%]"<<std::endl;
				std::cin>>m_Buf[0];
			}

			ULONG ratio;

			ratio=m_Buf[0];

			m_rid=m_ManipulatorCommonInterface_Middle->setSpeedCartesian(ratio);
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;
		
		}else if(mode == 230){
			std::cout<<"M30:֐ߓ쎞̑xݒ"<<std::endl;

			if( c == 'm' ){
				//cin͂m_Bufւ̑
				std::cout<<"ő哮쎞ɑ΂銄[%]"<<std::endl;
				std::cin>>m_Buf[0];
			}

			ULONG ratio;

			ratio=m_Buf[0];

			m_rid=m_ManipulatorCommonInterface_Middle->setSpeedJoint(ratio);
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;

		}else if(mode == 231){
			std::cout<<"M31:Wn̉~ʕ(Ύw)"<<std::endl;

			if( c == 'm' ){
				//cin͂m_Bufւ̑
				std::cout<<"p_̈ʒuW:x[mm]"<<std::endl;
				std::cin>>m_Buf[0];
				std::cout<<"p_̈ʒuW:y[mm]"<<std::endl;
				std::cin>>m_Buf[1];
				std::cout<<"p_̈ʒuW:z[mm]"<<std::endl;
				std::cin>>m_Buf[2];
				std::cout<<"p_̎ppx:A[deg]"<<std::endl;
				std::cin>>m_Buf[3];
				std::cout<<"p_̎ppx:B[deg]"<<std::endl;
				std::cin>>m_Buf[4];
				std::cout<<"p_̎ppx:C[deg]"<<std::endl;
				std::cin>>m_Buf[5];
				std::cout<<"ڕW_̈ʒuW:x[mm]"<<std::endl;
				std::cin>>m_Buf[6];
				std::cout<<"ڕW_̈ʒuW:y[mm]"<<std::endl;
				std::cin>>m_Buf[7];
				std::cout<<"ڕW_̈ʒuW:z[mm]"<<std::endl;
				std::cin>>m_Buf[8];
				std::cout<<"ڕW_̎ppx:A[deg]"<<std::endl;
				std::cin>>m_Buf[9];
				std::cout<<"ڕW_̎ppx:B[deg]"<<std::endl;
				std::cin>>m_Buf[10];
				std::cout<<"ڕW_̎ppx:C[deg]"<<std::endl;
				std::cin>>m_Buf[11];
			}

			m_Buf[0] = m_Buf[0]/1000.0;//[mm]->[m]
			m_Buf[1] = m_Buf[1]/1000.0;//[mm]->[m]
			m_Buf[2] = m_Buf[2]/1000.0;//[mm]->[m]
			m_Buf[6] = m_Buf[6]/1000.0;//[mm]->[m]
			m_Buf[7] = m_Buf[7]/1000.0;//[mm]->[m]
			m_Buf[8] = m_Buf[8]/1000.0;//[mm]->[m]

			JARA_ARM::CarPosWithElbow pos1,pos2;

			//deg->redϊ
			m_Buf[3]=m_Buf[3]/180.0*m_PI;
			m_Buf[4]=m_Buf[4]/180.0*m_PI;
			m_Buf[5]=m_Buf[5]/180.0*m_PI;

			//pX->Y->Z]ł̒l
			//1
			pos1.carPos[0][0]=cos(m_Buf[5])*cos(m_Buf[4]);
			pos1.carPos[1][0]=sin(m_Buf[5])*cos(m_Buf[4]);
			pos1.carPos[2][0]=-sin(m_Buf[4]);
			
			//2
			pos1.carPos[0][1]=-sin(m_Buf[5])*cos(m_Buf[3])+cos(m_Buf[5])*sin(m_Buf[4])*sin(m_Buf[3]);
			pos1.carPos[1][1]=cos(m_Buf[5])*cos(m_Buf[3])+sin(m_Buf[5])*sin(m_Buf[4])*sin(m_Buf[3]);
			pos1.carPos[2][1]=cos(m_Buf[4])*sin(m_Buf[3]);
			
			//3
			pos1.carPos[0][2]=sin(m_Buf[5])*sin(m_Buf[3])+cos(m_Buf[5])*sin(m_Buf[4])*cos(m_Buf[3]);
			pos1.carPos[1][2]=-cos(m_Buf[5])*sin(m_Buf[3])+sin(m_Buf[5])*sin(m_Buf[4])*cos(m_Buf[3]);
			pos1.carPos[2][2]=cos(m_Buf[4])*cos(m_Buf[3]);
			
			//4
			pos1.carPos[0][3]=m_Buf[0];
			pos1.carPos[1][3]=m_Buf[1];
			pos1.carPos[2][3]=m_Buf[2];

			//deg->redϊ
			m_Buf[9]=m_Buf[9]/180.0*m_PI;
			m_Buf[10]=m_Buf[10]/180.0*m_PI;
			m_Buf[11]=m_Buf[11]/180.0*m_PI;

			//pX->Y->Z]ł̒l
			//1
			pos2.carPos[0][0]=cos(m_Buf[11])*cos(m_Buf[10]);
			pos2.carPos[1][0]=sin(m_Buf[11])*cos(m_Buf[10]);
			pos2.carPos[2][0]=-sin(m_Buf[10]);
			
			//2
			pos2.carPos[0][1]=-sin(m_Buf[11])*cos(m_Buf[9])+cos(m_Buf[11])*sin(m_Buf[10])*sin(m_Buf[9]);
			pos2.carPos[1][1]=cos(m_Buf[11])*cos(m_Buf[9])+sin(m_Buf[11])*sin(m_Buf[10])*sin(m_Buf[9]);
			pos2.carPos[2][1]=cos(m_Buf[10])*sin(m_Buf[9]);
			
			//3
			pos2.carPos[0][2]=sin(m_Buf[11])*sin(m_Buf[9])+cos(m_Buf[11])*sin(m_Buf[10])*cos(m_Buf[9]);
			pos2.carPos[1][2]=-cos(m_Buf[11])*sin(m_Buf[9])+sin(m_Buf[11])*sin(m_Buf[10])*cos(m_Buf[9]);
			pos2.carPos[2][2]=cos(m_Buf[10])*cos(m_Buf[9]);
			
			//4
			pos2.carPos[0][3]=m_Buf[6];
			pos2.carPos[1][3]=m_Buf[7];
			pos2.carPos[2][3]=m_Buf[8];

			m_rid=m_ManipulatorCommonInterface_Middle->moveCircularCartesianAbs(pos1,pos2);
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;

			do{
				m_ManipulatorCommonInterface_Common->getState(m_state);
				if(m_state&0x4){
					std::cout <<"A["<< std::endl;
					RTC_ERROR(("A["));
					return RTC::RTC_ERROR;
				}
			}while(m_state&0x2);
				
		}else if(mode == 232){
			std::cout<<"M32:Wn̉~ʕ(Ύw)"<<std::endl;

			if( c == 'm' ){
				//cin͂m_Bufւ̑
				std::cout<<"p_̈ʒuW:x[mm]"<<std::endl;
				std::cin>>m_Buf[0];
				std::cout<<"p_̈ʒuW:y[mm]"<<std::endl;
				std::cin>>m_Buf[1];
				std::cout<<"p_̈ʒuW:z[mm]"<<std::endl;
				std::cin>>m_Buf[2];
				std::cout<<"p_̎ppx:A[deg]"<<std::endl;
				std::cin>>m_Buf[3];
				std::cout<<"p_̎ppx:B[deg]"<<std::endl;
				std::cin>>m_Buf[4];
				std::cout<<"p_̎ppx:C[deg]"<<std::endl;
				std::cin>>m_Buf[5];
				std::cout<<"ڕW_̈ʒuW:x[mm]"<<std::endl;
				std::cin>>m_Buf[6];
				std::cout<<"ڕW_̈ʒuW:y[mm]"<<std::endl;
				std::cin>>m_Buf[7];
				std::cout<<"ڕW_̈ʒuW:z[mm]"<<std::endl;
				std::cin>>m_Buf[8];
				std::cout<<"ڕW_̎ppx:A[deg]"<<std::endl;
				std::cin>>m_Buf[9];
				std::cout<<"ڕW_̎ppx:B[deg]"<<std::endl;
				std::cin>>m_Buf[10];
				std::cout<<"ڕW_̎ppx:C[deg]"<<std::endl;
				std::cin>>m_Buf[11];
			}

			m_Buf[0] = m_Buf[0]/1000.0;//[mm]->[m]
			m_Buf[1] = m_Buf[1]/1000.0;//[mm]->[m]
			m_Buf[2] = m_Buf[2]/1000.0;//[mm]->[m]
			m_Buf[6] = m_Buf[6]/1000.0;//[mm]->[m]
			m_Buf[7] = m_Buf[7]/1000.0;//[mm]->[m]
			m_Buf[8] = m_Buf[8]/1000.0;//[mm]->[m]

			JARA_ARM::CarPosWithElbow pos1,pos2;

			//deg->redϊ
			m_Buf[3]=m_Buf[3]/180.0*m_PI;
			m_Buf[4]=m_Buf[4]/180.0*m_PI;
			m_Buf[5]=m_Buf[5]/180.0*m_PI;

			//pX->Y->Z]ł̒l
			//1
			pos1.carPos[0][0]=cos(m_Buf[5])*cos(m_Buf[4]);
			pos1.carPos[1][0]=sin(m_Buf[5])*cos(m_Buf[4]);
			pos1.carPos[2][0]=-sin(m_Buf[4]);
			
			//2
			pos1.carPos[0][1]=-sin(m_Buf[5])*cos(m_Buf[3])+cos(m_Buf[5])*sin(m_Buf[4])*sin(m_Buf[3]);
			pos1.carPos[1][1]=cos(m_Buf[5])*cos(m_Buf[3])+sin(m_Buf[5])*sin(m_Buf[4])*sin(m_Buf[3]);
			pos1.carPos[2][1]=cos(m_Buf[4])*sin(m_Buf[3]);
			
			//3
			pos1.carPos[0][2]=sin(m_Buf[5])*sin(m_Buf[3])+cos(m_Buf[5])*sin(m_Buf[4])*cos(m_Buf[3]);
			pos1.carPos[1][2]=-cos(m_Buf[5])*sin(m_Buf[3])+sin(m_Buf[5])*sin(m_Buf[4])*cos(m_Buf[3]);
			pos1.carPos[2][2]=cos(m_Buf[4])*cos(m_Buf[3]);
			
			//4
			pos1.carPos[0][3]=m_Buf[0];
			pos1.carPos[1][3]=m_Buf[1];
			pos1.carPos[2][3]=m_Buf[2];

			//deg->redϊ
			m_Buf[9]=m_Buf[9]/180.0*m_PI;
			m_Buf[10]=m_Buf[10]/180.0*m_PI;
			m_Buf[11]=m_Buf[11]/180.0*m_PI;

			//pX->Y->Z]ł̒l
			//1
			pos2.carPos[0][0]=cos(m_Buf[11])*cos(m_Buf[10]);
			pos2.carPos[1][0]=sin(m_Buf[11])*cos(m_Buf[10]);
			pos2.carPos[2][0]=-sin(m_Buf[10]);
			
			//2
			pos2.carPos[0][1]=-sin(m_Buf[11])*cos(m_Buf[9])+cos(m_Buf[11])*sin(m_Buf[10])*sin(m_Buf[9]);
			pos2.carPos[1][1]=cos(m_Buf[11])*cos(m_Buf[9])+sin(m_Buf[11])*sin(m_Buf[10])*sin(m_Buf[9]);
			pos2.carPos[2][1]=cos(m_Buf[10])*sin(m_Buf[9]);
			
			//3
			pos2.carPos[0][2]=sin(m_Buf[11])*sin(m_Buf[9])+cos(m_Buf[11])*sin(m_Buf[10])*cos(m_Buf[9]);
			pos2.carPos[1][2]=-cos(m_Buf[11])*sin(m_Buf[9])+sin(m_Buf[11])*sin(m_Buf[10])*cos(m_Buf[9]);
			pos2.carPos[2][2]=cos(m_Buf[10])*cos(m_Buf[9]);
			
			//4
			pos2.carPos[0][3]=m_Buf[6];
			pos2.carPos[1][3]=m_Buf[7];
			pos2.carPos[2][3]=m_Buf[8];

			m_rid=m_ManipulatorCommonInterface_Middle->moveCircularCartesianRel(pos1,pos2);
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;

			do{
				m_ManipulatorCommonInterface_Common->getState(m_state);
				if(m_state&0x4){
					std::cout <<"A["<< std::endl;
					RTC_ERROR(("A["));
					return RTC::RTC_ERROR;
				}
			}while(m_state&0x2);
				
		}else if(mode == 233){
			std::cout<<"M33:_Äʒuݒ"<<std::endl;

			JARA_ARM::ManipInfo_var minfovar;
			JARA_ARM::ManipInfo minfo;
			JARA_ARM::JointPos jnt;

			m_rid=m_ManipulatorCommonInterface_Common->getManipInfo(minfovar);
			minfo=minfovar;
			m_len=minfo.axisNum;
			jnt.length(m_len);

			if( c == 'm' ){
				//cin͂m_Bufւ̑
				std::cout<<"_ʒuł̊֐ߍWl"<<std::endl;
				for(i=0;i<m_len;i++){			
					std::cout <<"֐["<<i+1<<"]"<< std::endl;
					std::cin>>m_Buf[i];
				}
			}

			if(m_len <= 3){
				for(int i=0;i<m_len;i++){			
					jnt[i]=m_Buf[i]/1000.0;//[mm]->[m]
				}
			}else{
				for(int i=0;i<m_len;i++){			
					jnt[i]=m_Buf[i]*m_PI/180.0;//[deg]->[rad]
				}
			}
			

			m_rid=m_ManipulatorCommonInterface_Middle->setHome(jnt);
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;
				
		}else if(mode == 234){
			std::cout<<"M34:_Äʒu擾"<<std::endl;

			JARA_ARM::JointPos_var posvar;
			JARA_ARM::JointPos pos;

			m_rid=m_ManipulatorCommonInterface_Middle->getHome(posvar);
			if(m_rid->id == 0){//
				std::cout << "_Aʒuł̊֐ߍWl"<< std::endl;
				pos=posvar;
				m_len=pos.length();
				for(int i=0;i<m_len;i++){
					std::cout << "֐J"<<i+1<<":"<<pos[i]<< std::endl;
				}

			}else{//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
			}
			std::cout<<std::endl;
			
				
		}else if(mode == 235){
			std::cout<<"M35:_A"<<std::endl;

			m_rid=m_ManipulatorCommonInterface_Middle->goHome();
			if(m_rid->id != 0){//Error
				std::cout << std::endl<< m_rid->comment << std::endl;
				return RTC::RTC_ERROR;
			}
			std::cout<<std::endl;

			do{
				m_ManipulatorCommonInterface_Common->getState(m_state);
				if(m_state&0x4){
					std::cout <<"A["<< std::endl;
					RTC_ERROR(("A["));
					return RTC::RTC_ERROR;
				}
			}while(m_state&0x2);
				
		}

		 return RTC::RTC_OK;

}



extern "C"
{
 
  void OperationCommandRTCInit(RTC::Manager* manager)
  {
    coil::Properties profile(operationcommandrtc_spec);
    manager->registerFactory(profile,
                             RTC::Create<OperationCommandRTC>,
                             RTC::Delete<OperationCommandRTC>);
  }
  
};


